// BringUpTest.cpp: Hauptprojektdatei.

#include "stdafx.h"

#include "Form1.h"

#include "WndMessageHolder.h"

using namespace BringUpTest;

using namespace System::Threading;
using namespace System::Diagnostics;

[STAThreadAttribute]
int main(array<System::String ^> ^args)
{
  // Aktivieren visueller Effekte von Windows XP, bevor Steuerelemente erstellt werden
  Application::EnableVisualStyles();
  Application::SetCompatibleTextRenderingDefault(false); 

  String ^strInstanceMutex = "{BE3A098C-D815-43e7-B8E2-5EC55CBC5306}";
#ifdef _DEBUG
  strInstanceMutex += "_debug";
#endif

  bool bIMTheOne;
  Mutex ^mtxInstance = gcnew Mutex(true, strInstanceMutex, bIMTheOne);
  if (bIMTheOne) {
    // Hauptfenster erstellen und ausfhren
    Application::Run(gcnew Form1());
    mtxInstance->Close();
  } else {
#ifdef _DEBUG
    Debug::WriteLine("BringUpTest already running, sending WM_BRINGUP message...");
#endif
    WndMessageHolder ^wmh = WndMessageHolder::GetInstance();
    bool bResult = wmh->PostMessage_((IntPtr)HWND_BROADCAST, wmh->WM_BRINGUP, (IntPtr)0, (IntPtr)0);
    Trace::Assert(bResult, String::Format("Broadcasting WM_BRINGUP message failed (code {0})",
      WndMessageHolder::GetLastError_()));
  }
  return 0;
}
